//===-- StatsCollector_Fer.cpp - Collects statistics about instructions ---===//
//
//                     The LLVM Compiler Infrastructure
//
// Author: Fernando Magno Quintao Pereira
//
//===----------------------------------------------------------------------===//
//
// This pass collects some statistics about the target program.
//
//===----------------------------------------------------------------------===//

#ifndef STATS_COLLECTOR_FER_H
#define STATS_COLLECTOR_FER_H

#include "llvm/Pass.h"

namespace llvm {

    class StatsCollector_Fer : public MachineFunctionPass {

        public:

        /// reporst that this pass does not change anything on the control
        /// flow graph.
        virtual void getAnalysisUsage(AnalysisUsage &AU) const {
            AU.setPreservesAll();
        }

        /// Informs the name of the pass, so it can appear in tools like
        /// llc.
        virtual const char *getPassName() const {
            return "Stats collector - Fernando.";
        }

        private:

        /// runOnMachineFunction - collects liveness information about each
        /// edge of the control flow graph.
        bool runOnMachineFunction(MachineFunction &mf);

    };

}

#endif
