//===----------- GraphFer_Fer.cpp - Bank of Machine Registers -------------===//
//
//              Register Allocation via Coloring of Chordal Graphs 
//
// This class defines a undirected graph.
//
// Date: March 2nd 2007
//
//===----------------------------------------------------------------------===//
//
//
//===----------------------------------------------------------------------===//


#ifndef GRAPH_FER_H
#define GRAPH_FER_H

namespace llvm {

  class MachineFunction;
  class Node_Fer;

  class Graph_Fer {

    public:

    ///
    ~Graph_Fer() {
        this->clear();
    }

    ///
    void connect(unsigned v, unsigned u);

    ///
    bool are_adj(unsigned u, unsigned v);

    ///
    void remove(unsigned u);

    ///
    const void dump(MachineFunction & mf) const;

    ///
    void clear();

    ///
    bool contains(unsigned u) {
        return this->nodes.find(u) != this->nodes.end();
    }

    ///
    unsigned size() {
        return this->nodes.size();
    }

    ///
    const Node_Fer * Graph_Fer::get_node(unsigned u) {
        return this->nodes[u];
    }

    private:

    ///
    std::map<unsigned, Node_Fer *> nodes;

  };

}

#endif
