//===---------------- Node_Fer.cpp - Printing prototype -------------------===//
//
//              Register Allocation via Coloring of Chordal Graphs 
//
// This is the node of a graph.
//
// Date: May 27th, 2006
//
//===----------------------------------------------------------------------===//
//
//===----------------------------------------------------------------------===//

#ifndef NODE_FER_H
#define NODE_FER_H

#include <set>
#include <iostream>

namespace llvm {

  class MachineFunction;

  class Node_Fer {

    public:

    Node_Fer(unsigned n) : value(n) {
    }

    ~Node_Fer() {
      this->neighbors.clear();
    }

    bool link(Node_Fer * n);

    bool unlink(Node_Fer * n);

    void unlink_all();

    const std::set<Node_Fer *> & get_neighbors() const;

    const std::string to_string(const MachineFunction & mf) const;

    unsigned degree() const {
        return this->neighbors.size();
    }

    bool is_neighbor(Node_Fer * n) const {
        return this->neighbors.find(n) != this->neighbors.end();
    }

    unsigned get_value() const {
        return this->value;
    }

    private:

    unsigned value;

    std::set<Node_Fer *> neighbors;

  };

}

#endif
